<?php

declare(strict_types=1);

namespace Drupal\layout_builder_iframe_modal\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;

/**
 * Controller to render the iframe redirect page.
 */
class RedirectController extends ControllerBase {

  /**
   * Renders and returns the redirect page.
   *
   * @return \Symfony\Component\HttpFoundation\Response
   *   The response.
   */
  public function content(): Response {
    $build = ['#theme' => 'lbim_redirect'];
    $output = \Drupal::service('renderer')->renderRoot($build);

    $response = new Response();
    $response->setContent($output);

    return $response;
  }

}
